0001 ORG    ORG   00000H  *  Program starting address
0002 ********************************************************
0003 **                                                    **
0004 **      NEWETT AWL'S SOL-20 SCREEN BUBBLE SORT        **
0005 **                                                    **
0006 **                                                    **
0007 **     INSTRUCTIONS:  Type a lot of "garbage" on the  **
0008 **         screen and then execute the program at     **
0009 **         address zero for the sight of your life.   **
0010 **                                                    **
0011 ********************************************************
0012 *
0013 SORT   LHLD  SIZE    * Get size of sort area
0014        MOV   A,L     * See if size is
0015        ORA   H       * ...ZER0
0016        JZ    DONE    * If yes, leave
0017 CON1   SHLD  COMPCT  * Set up comparison point
0018        SHLD  ITMCNT  * Reserve item count
0019        LXI   B,0     * Clear B/C
0020        LXI   H,TOP   * Point to top of area
0021        LXI   D,TOP+1   * Point to TOP+1 of area
0022 CON2   LDAX  D       * Get item "B" from area
0023        CMP   M       * Compare to item "A"
0024        JNC   CON3    * Goto CON3 if A<B
0025        MOV   C,M     * Get "A" to reg. 'C'
0026        MOV   M,A     * Put "B" where "A" was
0027        MOV   A,C     * Put "A" where "B" was
0028        STAX  D       * Put "A" where "B" was
0029        MOV   B,A     * Use byte for swap flag
0030 CON3   INX   H       * Increment "A" pointer
0031        INX   D       * Increment "B" pointer
0032        PUSH  H       * Keep memory reference
0033        LHLD  ITMCNT  * Restore item count
0034        DCX   H       * Decrement it
0035        SHLD  ITMCNT  * Restore item count
0036        MOV   A,L     * Test IF
0037        ORA   H       * ...Item count is zero
0038        POP   H       * Get memory reference back
0039        JNZ   CON2    * No, go do more
0040        XRA   A       * Clear flags
0041        ADD   B       * Get swap flag
0042        LHLD  COMPCT  * Get new item count
0043        DCX   H       * Reduce compare count by 1
0044        JNZ   CON1    * Goto CON1 if it did swap
0045 DONE   RET
0046 *
0047 * WORKING STORAGE AREA
0048 *
0049 ITMCNT   DW   0      * Inner item count
0050 COMPCT   DW   0      * No. of items in the list
0051 SIZE     DW   1023   * Arbitrary length
0052 TOP      EQU  0CC00H   * Use screen for SORT area
0053 ******
0054 END      END
